<template>
    <div>
        <v-dialog v-model="dialog" persistent class="resizes">
            <v-card>
                <v-card-title style="background-color:black;">
                    <h1 style="color:white;" class="catName">
                        {{ subcategory.id ? 'EDITAR SUBCATEGORIA' : 'CREAR SUBCATEGORIA' }}
                    </h1>
                </v-card-title>
                <v-card-text>
                    <v-form v-model="isValidForm" lazy-validation ref="form">
                        <v-container>
                            <v-row>
                                <v-col>
                                    <span>Nombre por defecto de la subcategoria</span>
                                    <v-text-field
                                        v-model="auxSubCategoriy.name"
                                        required
                                        class="tf1"
                                        style="margin-top: 15px;"
                                        :rules="subcategoryRules"
                                    ></v-text-field>
                                </v-col>
                                <v-col cols="12" v-if="langsMenu.length > 1">
                                    <template>Nombre por lenguaje</template>
                                    <v-row class="table-title bordered" style="border-top:none;">
                                        <v-col v-for="lan in langsMenu" :key="lan.id">
                                            <span class="titles">{{ lan.name }}</span>
                                        </v-col>
                                    </v-row>
                                    <v-row class="table-body bordered" style="border-top:none;">
                                        <v-col v-for="lan in langsMenu" :key="lan.id">
                                            <span class="titles">
                                                <v-text-field
                                                    :label="lan.language"
                                                    :value="
                                                        langsSubCategoryFromComponent.get(lan.id)
                                                            ? langsSubCategoryFromComponent.get(lan.id).text
                                                            : undefined
                                                    "
                                                    @input="input => changeLangText(input, lan.id, lan.language)"
                                                    :rules="subcategoryRules"
                                                ></v-text-field
                                            ></span>
                                        </v-col>
                                    </v-row>
                                </v-col>
                            </v-row>
                            <v-row>
                                <v-col cols="5">
                                    <span>Icono de subcategoria</span>
                                    <v-row>
                                        <v-col lg="6" cols="12">
                                            <v-card
                                                height="200px"
                                                width="200px"
                                                v-cloak
                                                @click="$refs.uploader.$refs.input.click()"
                                                @drop.prevent="fileDropped"
                                                :img="previewImg(fileSubCategory)"
                                                @dragover.prevent="dropzone(true)"
                                                @dragenter="dropzone(true)"
                                                @dragleave="dropzone(false)"
                                                style="display: inline-block; align-items: center;"
                                                class="uploader"
                                            >
                                                <div style="position: absolute; margin-top: 25%;">
                                                    <v-icon
                                                        class="drop-icon"
                                                        style="display: contents;"
                                                        v-if="!dragover"
                                                        color="yellow darken-2"
                                                        size="50"
                                                        >mdi-cloud-upload-outline</v-icon
                                                    >
                                                    <v-icon
                                                        class="drop-icon"
                                                        style="display: contents;"
                                                        v-if="dragover"
                                                        color="yellow darken-2"
                                                        size="50"
                                                        >mdi-book-plus</v-icon
                                                    >
                                                    <v-chip class="ma-2">
                                                        <span class="uploadLabel">Arrastra aquí</span>
                                                    </v-chip>
                                                </div>
                                            </v-card>
                                        </v-col>
                                        <v-col lg="4" cols="12">
                                            <v-file-input
                                                accept="image/*"
                                                v-model="fileSubCategory"
                                                show-size
                                                ref="uploader"
                                            ></v-file-input>
                                            <v-btn
                                                class="upimg1"
                                                color="#fdb947"
                                                rounded
                                                @click="uploadFile(fileSubCategory)"
                                                v-if="subcategory.id ? true : false"
                                                >Actualizar Imagen</v-btn
                                            >
                                        </v-col>
                                    </v-row>
                                </v-col>
                                <v-col>
                                    <div class="d-flex mx-5 mb-5" style="align-items:center;">
                                        <HexCheckBox v-model="auxSubCategoriy.active"></HexCheckBox>
                                        <span>¿Activo?</span>
                                    </div>
                                </v-col>
                                <v-col>
                                    <div class="d-flex mx-5 mb-5" style="align-items:center;">
                                        <span>Orden de la subcategoria</span>
                                        <v-text-field
                                            v-model="auxSubCategoriy.order"
                                            class="tf1"
                                            style="margin-top: 15px; justify-items: center;"
                                        ></v-text-field>
                                    </div>
                                </v-col>
                            </v-row>
                        </v-container>
                    </v-form>
                </v-card-text>
                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="yellow darken-1" @click="closeWindow" class="btnwidth">CERRAR</v-btn>
                    <v-btn
                        color="yellow darken-1"
                        @click="saveSubCategory($event, auxSubCategoriy)"
                        class="btnwidth"
                        :disabled="!isValidForm"
                        >GUARDAR</v-btn
                    >
                </v-card-actions>
            </v-card>
        </v-dialog>
    </div>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
import { Subcategory as SubCategoryModel } from '@/model/menu/Subcategory';
import { LangMenu } from '@/model/menu/LangMenu';
import { LangText } from '@/model/LangText';
import { CATEGORIES, CATEGORY_LANGS_NAME, MENUS, SUBCATEGORIES } from '@/config/collectionsName';
import { db } from '@/config/firebase';
import { serializeLangText } from '@/config/serializables';
import LangList from '@/components/menu/LangList.vue';
import HexCheckBox from '@/components/commons/HexCheckBox.vue';
import { getFile } from '@/services/StorageService';
import { SubcategoryService } from '@/services/SubcategoryService';

@Component({ components: { LangList, HexCheckBox } })
export default class Subcategory extends Vue {
    @Prop({ default: new SubCategoryModel('', false, '', '', 0) })
    subcategory!: SubCategoryModel;
    @Prop({ default: () => [] })
    langsMenu!: LangMenu[];
    @Prop({ default: false })
    dialog!: boolean;
    @Prop({ required: true })
    categoryId!: string;
    @Prop({ required: true })
    menuId!: string;

    auxSubCategoriy: SubCategoryModel = new SubCategoryModel('', false, '', '', 0);
    langsSubCategoryFromFire: LangText[] = [];
    langsSubCategoryFromComponent: Map<string, LangText> = new Map();
    isValidForm = true;

    fileSubCategory = new File([], '', undefined);
    filePreview = '';
    dragover = false;

    private readonly subcategoryService = new SubcategoryService();

    subcategoryRules = [
        (v: string) => (v && v.length > 1) || 'Este elemento es requerido,debe tener por lo menos 2 caracteres'
    ];

    saveSubCategory(event: Event, subcategory?: SubCategoryModel) {
        const isValid = (this.$refs.form as Vue & { validate: () => boolean }).validate();
        if (isValid) {
            const langSubCategoriesToFire = Array.from(this.langsSubCategoryFromComponent.values()).filter(
                langSubCat => langSubCat.text
            );
            //  console.log('arr', langSubCategoriesToFire);
            this.$emit('saveSubCategory', subcategory, langSubCategoriesToFire, this.fileSubCategory);
            this.$emit('setShowSubCategory', false);
        }
    }

    async closeWindow() {
        this.auxSubCategoriy = Object.assign(this.auxSubCategoriy, this.subcategory);
        this.$emit('setShowSubCategory', false);
    }

    changeLangText(input: string, langId: string, lang: string) {
        this.langsSubCategoryFromComponent.set(langId, new LangText(langId, lang, input));
    }

    fileDropped(dragevent: DragEvent) {
        if (dragevent.dataTransfer) {
            this.dragover = false;
            this.fileSubCategory = dragevent.dataTransfer.files[0];
        }
    }
    previewImg(file: File) {
        if (file.size !== 0) {
            return URL.createObjectURL(file);
        } else {
            return this.filePreview;
        }
    }
    dropzone(ready: boolean) {
        this.dragover = ready;
    }
    async getFilesPreview(file: string) {
        return await getFile(file || '');
    }

    async uploadFile(file: File) {
        try {
            await this.subcategoryService.updateSubCategoryIconFile(
                this.menuId,
                this.categoryId,
                this.subcategory,
                file
            );
            this.$emit('setMessage', 'IMAGEN DELIVERY ACTUALIZADA', 'success');
        } catch (e) {
            const error = e as Error;
            this.$emit('setMessage', 'Ha surgido un problema al realizar esta accion' + error.message, 'error');
        }
    }
    @Watch('subcategory')
    async onCategoryChange(newSubCategory: SubCategoryModel | null) {
        console.log('onSubCategoryChange', newSubCategory);
        if (newSubCategory && newSubCategory.id) {
            await this.$bind(
                'langsSubCategoryFromFire',
                db
                    .collection(MENUS)
                    .doc(this.menuId)
                    .collection(CATEGORIES)
                    .doc(this.categoryId)
                    .collection(SUBCATEGORIES)
                    .doc(this.subcategory.id)
                    .collection(CATEGORY_LANGS_NAME),
                { serialize: serializeLangText }
            );
            //  console.log('from fire', this.langsSubCategoryFromFire);
        }

        if (!newSubCategory?.id) {
            this.langsSubCategoryFromFire = [];
        }
        // console.log('reset', this.langsSubCategoryFromFire);
        this.langsSubCategoryFromComponent = new Map();
        this.fileSubCategory = new File([], newSubCategory?.icon || '');
        this.langsSubCategoryFromFire.forEach(langSubCategory =>
            this.langsSubCategoryFromComponent.set(langSubCategory.id, langSubCategory)
        );
        // console.log('from fire', this.auxSubCategoriy);
        this.auxSubCategoriy = Object.assign(this.auxSubCategoriy, this.subcategory);
        //  console.log('from fire', this.auxSubCategoriy);
        this.filePreview = await this.getFilesPreview(this.subcategory.icon);
    }
}
</script>

<style type="text/css">
.uploader {
    border: 7px;
    border-style: dashed;
    border-color: #dde3f3 !important;
}
@media (max-width: 700px) {
    .catName {
        font-size: 20px;
    }
    .btnwidth {
        position: relative;
        width: 150px;
    }
    .tf1 {
        width: 800px;
        color: red;
    }
}
@media screen and (max-width: 1241px) {
}
</style>
